#include <LiquidCrystal.h>//Llibreria LCD
#include <TimerOne.h>//Llibreria per configurar timer 

LiquidCrystal lcd(14, 15, 16, 17, 18, 19); //(RS,EN,d4,d5,d6,d7)Definim Pins LCD

//Definim els pins a utilitzar
const int dirPin = 2;
const int stepPin = 3;
const int camara = 12;
const int rebobinar =4; 
const int capturar = 6; 
const int endavant = 5; 
const int inductiu = 7;
const int boto=8;
const int RS=14;
const int EN=15;
const int Dades4=16;
const int Dades5=17;
const int Dades6=18;
const int Dades7=19;

//Definició de variables
int hores=0,minuts=10,segons=0,metres=15, MemBoto=0,comptador=0;
int deteccio=0;
int fotogrames=0;
int ModeEndavant=0,ModeRebobinar=0,ModeCaptura=0;
char python='0';
 
void setup() {
  Serial.begin(9600); //Definim velocitat port sèrie

  //Definim pins com a entrades o sortides
  pinMode(dirPin, OUTPUT);
  pinMode(stepPin, OUTPUT);
  pinMode(camara,OUTPUT);
  pinMode(rebobinar,INPUT);
  pinMode(capturar,INPUT);
  pinMode(endavant,INPUT);
  pinMode(inductiu,INPUT);
  pinMode(RS, OUTPUT);
  pinMode(EN, OUTPUT);
  pinMode(Dades4, OUTPUT);
  pinMode(Dades5, OUTPUT);
  pinMode(Dades6, OUTPUT);
  pinMode(Dades7, OUTPUT);
  pinMode(boto, INPUT); 
   
  lcd.begin(16, 2); // Fixem el numero de caràcters i files
  Timer1.initialize(1000000);  // Interrupció cada 1 segon
  Timer1.attachInterrupt(ISR_Blink); //Interrupcio associada a ISR_Blink
}

void loop(){  
  // Mode captura automàtica
  while((digitalRead(capturar)==HIGH) && (digitalRead(endavant)==HIGH) && (digitalRead(rebobinar)==LOW) && (python=='0')){ 
    ModeCaptura=1; //Memòria per saber que s'està en el mode captura
    if (Serial.available()>0){//Si el port sèrie està disponible
      python = Serial.read();//Llegim el que hi ha en el port sèrie
    } 
    if(digitalRead(inductiu)==HIGH){ //Si l'inductiu detecta
      deteccio=deteccio+1;
    }
    if((digitalRead(inductiu)==LOW) && deteccio>=1){ //Inductiu deixa de detectar
      comptador=comptador+1;
      deteccio=0;
    }  
    if(comptador<3){ //Mentre l'inductiu no detecta tres vegades seguim girant
      digitalWrite(dirPin, HIGH); //Establim direcció endavant
      digitalWrite(stepPin, HIGH); // Executem un pas
      delayMicroseconds(750);//Definim temps entre pas i pas
      digitalWrite(stepPin, LOW);
      delayMicroseconds(700);
    }else if(comptador>=3){ //Si es detecta per tercera vega
      digitalWrite(12,HIGH); //Disparem la càmera
      fotogrames=fotogrames +1; //Incrementem el nombre de fotogrames
      delay(200);//Donem temps a la càmara per fer la foto
      digitalWrite(12,LOW);
      comptador=0; //Reiniciem el comptador
    }
  }
 //Mode endavant. Passa la pel·lícula fins que es pari manualment
  while((digitalRead(rebobinar)==LOW) && (digitalRead(endavant)==HIGH) && (digitalRead(capturar)==LOW)){
    ModeEndavant=1;//Activem la memòria de mode endavant
    ModeRebobinar=0;//Reiniciem la memòria del mode rebobinador
    digitalWrite(dirPin, HIGH);//Executem passos endavant
    digitalWrite(stepPin, HIGH);
    delayMicroseconds(550);
    digitalWrite(stepPin, LOW);
    delayMicroseconds(350); 
  }
 //Mode rebobinar
  while((digitalRead(rebobinar)==HIGH) && (digitalRead(endavant)==LOW) && (digitalRead(capturar)==LOW) ){ 
    ModeRebobinar=1;//Activem la memòria de rebobinar
    ModeEndavant=0;//Reiniciem la memporia del mode endavant
    digitalWrite(dirPin, LOW);//Executem passos endarrera
    digitalWrite(stepPin, HIGH);
    delayMicroseconds(550);
    digitalWrite(stepPin, LOW);
    delayMicroseconds(350);
  }
 //Mode OFF  
  while((digitalRead(rebobinar)==HIGH) && (digitalRead(endavant)==HIGH)){ 
    delay(100);//Petit delay per el canvi de velocitat
    python='0';//Reiniciem la variable rebuda pel codi python
    fotogrames=0;//Reiniciem el nombre de fotogrames
    deteccio=0; //Reiniciem la variable de deteccio
    comptador=0;//Reinicime el comptador de detecció
    while(ModeEndavant==1){//Si veniem del mode endavant  
      digitalWrite(dirPin, HIGH);//Seguim girant en el mateix sentit
      digitalWrite(stepPin, HIGH);
      delayMicroseconds(550);
      digitalWrite(stepPin, LOW);
      delayMicroseconds(350);
      if(digitalRead(inductiu)==HIGH){//Procés de detecció de l'inductiu
        deteccio=deteccio+1;
      }
      if((digitalRead(inductiu)==LOW) && deteccio>=1){ 
        comptador=comptador+1;
        deteccio=0;
      }
      if(comptador==2){//Quan l'inductiu deixa de detectar 2 cops
        comptador=0; //Parem motor i reiniciem variables
        ModeEndavant=0;
      }
  }
  while(ModeRebobinar==1){//Si veniem del mode rebobinar  
     digitalWrite(dirPin, LOW);//Seguim girant en el mateix sentit
     digitalWrite(stepPin, HIGH);
     delayMicroseconds(550);
     digitalWrite(stepPin, LOW);
     delayMicroseconds(350);
     if(digitalRead(inductiu)==HIGH){//Procés de detecció de l'inductiu
      deteccio=deteccio+1;
     }
     if((digitalRead(inductiu)==LOW) && deteccio>=1){ 
      comptador=comptador+1;
      deteccio=0;
     }
     if(comptador==2){//Quan l'inductiu deixa de detectar 2 cops
      comptador=0;//Parem motor i reiniciem variables
      ModeRebobinar=0;
     } 
  }
  //Activació del botó per canviar els metres de bobina
     if(digitalRead(boto)== HIGH && MemBoto==0){ 
       metres=metres + 15;
       MemBoto=1;//Activem memòria botó
     }else if(digitalRead(boto)== LOW){//Si es deixa de polsar
       MemBoto=0;//Reiniciem memòria botó
     }
   //Temps en funció dels metres de bobina 
     if(metres==15){
       hores=0;
       minuts=42;
       segons=0;
     }
     if(metres==30){
       hores=1;
       minuts=24;
       segons=0;
     }  
     if(metres==45){
       hores=2;
       minuts=6;
       segons=0;
     }  
     if(metres==60){
       hores=2;
       minuts=48;
       segons=0;
     }
     if(metres==75){//Si metres són 75 tornem a 15
       metres=15;
     }
     if(ModeCaptura==1){//Si veniem del mode captura
      lcd.clear();//Netegem pantalla
      ModeCaptura=0;//Reiniciem memòria
    }     
    lcd.setCursor(0,0); //Escrivim a la primera fila els metres de bobina
    lcd.print("Bobina:");  
    lcd.print(metres);
    lcd.print(" metres");
    lcd.setCursor(0,1); // A la segona fila escrivim el temps. 
    lcd.print("temps:");
    if(hores<10){ //Escrivim hores.Afegim un zero al davant si esta per sota de 10
    lcd.print("0");}
    lcd.print(hores);
    lcd.print(":");
    if(minuts<10){//Escrivim minuts.Afegim un zero al davant si esta per sota de 10 
    lcd.print("0");}
    lcd.print(minuts);
    lcd.print(":");
    if(segons<10){//Escrivim segons.Afegim un zero al davant si esta per sota de 10 
    lcd.print("0");}
    lcd.print(segons);
  }
}

void ISR_Blink() //Funció de la interrupció cada 1 segon
 {
  //Si estem en el mode automàtic i no s'ha acabat la pel·lícula
  if((python=='0') && ((digitalRead(capturar)==HIGH) && (digitalRead(endavant)==HIGH) && (digitalRead(rebobinar)==LOW))){ 
    segons=segons-1; //anem restant segons  
    lcd.clear();//Netegem la pantalla
    lcd.setCursor(0,0); //Escrivim a la primera fila els fotogrames capturats
    lcd.print("Fotogrames:");  
    lcd.print(fotogrames);
    lcd.setCursor(0,1); // A la segona fila escrivim el temps
    lcd.print("temps:");
    if(hores<10){ //S'executa la lògica per anar baixant el temps 
      lcd.print("0");}
      lcd.print(hores);
      lcd.print(":");
    if(minuts<10 && minuts>=0){
      lcd.print("0");
    }else if(minuts<0 && hores>0){
      minuts=59;
      hores= hores-1;
    }else if(minuts<0 && hores<=0){
      minuts=0;  
    }   
    lcd.print(minuts);
    lcd.print(":");
    if(segons<10 && segons>=0){ 
      lcd.print("0");
    }else if(segons<0 && minuts>0){
      segons=59;
      minuts= minuts-1; 
    }else if(segons<0 && minuts<=0 && hores>0){
      segons=59;
      minuts=59;
      hores=hores-1;
    }  
    lcd.print(segons);
  }else if((python=='1')){//Si el codi python avisa que s'ha acabat la pel·lícula
    lcd.clear();//Netegem la pantalla
    lcd.setCursor(0,0); //Escrivim a la primera fila els fotogrames totals
    lcd.print("Fotogrames:"); 
    lcd.print(fotogrames); 
    lcd.setCursor(0,1); // A la segona fila escrivim el temps
    lcd.print("Editant imatges");//Indiquem que el procés d'edició està en marxa
  }
}
 

